#include "Arduino.h"
#include <Wire.h> 
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h> 
#define SCREEN_WIDTH 128 // OLED display width, in pixels
#define SCREEN_HEIGHT 32
#define OLED_RESET     -1
Adafruit_SSD1306 display(SCREEN_WIDTH, SCREEN_HEIGHT, &Wire, OLED_RESET);


const int clk = 2;
const int dt = 3;


#define resistancePin A3
#define CS  A2
#define INC A0
#define UD  13
 

bool isINC = true;
int lastCount = 0;
volatile int virtualPosition = 0;
int A = 10;
int B = 11;
int C = 12;
int D = 6;

int ledA = 5;
int ledB = 4;
int ledC = 7;
int ledD = 8;

int ledAState = 0;
int ledBState = 0;
int ledCState = 0;
int ledDState = 0;

int buttonStateANew;
int buttonStateBNew;
int buttonStateCNew;
int buttonStateDNew;

int buttonStateAOld = 1;
int buttonStateBOld = 1;
int buttonStateCOld = 1;
int buttonStateDOld = 1;

String mappedValue;
 
void isr ()  {
  static unsigned long lastInterruptTime = 0;
  unsigned long interruptTime = millis();
  
  // If interrupts come faster than 5ms, assume it's a bounce and ignore
  if (interruptTime - lastInterruptTime > 5) {
    if (digitalRead(dt) == LOW)
    {
      virtualPosition-- ; // Could be -5 or -10
      digitalWrite(UD,LOW);
      digitalWrite(INC, LOW);
      display.clearDisplay();
      Text(mappedValue, 72, 18, 2, false);
      delay(50);
    }
    else {
      virtualPosition++ ; // Could be +5 or +10
      
      digitalWrite(UD,HIGH);
      digitalWrite(INC, LOW);
      display.clearDisplay();
      Text(mappedValue, 72, 18, 2, false);
      delay(50);
    }

    // Restrict value from 0 to +100
    //storeVolume();
    //virtualPosition = min(100, max(0, virtualPosition));


  }
  // Keep track of when we were here last (no more than every 5ms)
  lastInterruptTime = interruptTime;
}
 
void setup() {

display.begin(SSD1306_SWITCHCAPVCC, 0x3C);  
display.display();
//delay(200);
display.clearDisplay(); 

pinMode(clk,INPUT);
pinMode(dt,INPUT);  
pinMode(sw,INPUT);

pinMode(ledA, OUTPUT);
pinMode(ledB, OUTPUT);
pinMode(ledC, OUTPUT);
pinMode(ledD, OUTPUT);

pinMode(A, INPUT);
pinMode(B, INPUT);
pinMode(C, INPUT);
pinMode(D, INPUT);
 
Serial.begin (9600);
//ledA = EEPROM.read(0);
//ledB = EEPROM.read(0);
//ledC = EEPROM.read(0);
//ledD = EEPROM.read(0);

//digitalWrite(ledA, HIGH);
//digitalWrite(ledB, HIGH);
//digitalWrite(ledC, HIGH);
//digitalWrite(ledD, HIGH);

// Reads the initial state of the outputA

 attachInterrupt(digitalPinToInterrupt(clk), isr, LOW); 

pinMode(CS, OUTPUT);
digitalWrite(CS, LOW); // ON

// INC - LOW is active
pinMode(INC, OUTPUT);
digitalWrite(INC, HIGH); // OFF

// UP is high, DOWN is low
pinMode(UD, OUTPUT);

// Power up device
//Serial.println("Powering up X9C103");
//pinMode(PWR, OUTPUT);
//digitalWrite(PWR, HIGH);
delay(10);
}
 
void loop() {
 // Reads the "current" state of the outputA
   
 //String readVolume() =  String(count, 3);   
 //isINC = digitalRead(INC) == HIGH;
 
 bool volChange = false;
 
  if (virtualPosition != lastCount) {
  
    // Write out to serial monitor the value and direction
    Serial.print(virtualPosition > lastCount ? "Up  :" : "Down:");
    Serial.println(virtualPosition);
    Serial.println(readVolume());
    volChange = true;
    // Keep track of this new value
    lastCount = virtualPosition ;
    
    //delay(100);
    //display.clearDisplay();
    
    
  }

  //display.clearDisplay();
  //Text("MENU", 60,3,1,false);
  Text("VOLUME:          ", 4, 21, 1, false);
  
  display.display();
  
 button();
//if (volChange) {
   // storeVolume();
   // return true;
 // }
 // else
   // return false;
   //if (volChange) storeVolume();
 //delay(100);


}  






void button(){
buttonStateANew = digitalRead(A);
buttonStateBNew = digitalRead(B);
buttonStateCNew = digitalRead(C);
buttonStateDNew = digitalRead(D);

//display.clearDisplay();

  if (buttonStateAOld == 0 && buttonStateANew == 1) {
    // turn LED on:
   if (ledAState == 0){
   
    digitalWrite(ledA, HIGH);
    digitalWrite(ledD, LOW);
    digitalWrite(ledB, LOW);
    digitalWrite(ledC, LOW);
    ledAState=1;
    display.clearDisplay();
    Text("FM", 60,3,1,false);
    Text(mappedValue, 72, 18, 2, false);
    display.display();
    //EEPROM.write(0, ledA);
    
  } else {
    // turn LED off:
    digitalWrite(ledA, LOW);
    ledAState=0;
    display.clearDisplay();
    //EEPROM.write(0, ledA);
  }
  }
  buttonStateAOld = buttonStateANew;
  delay(5);
  
  
    if (buttonStateBOld == 0 && buttonStateBNew == 1) {
    // turn LED on:
   if (ledBState == 0){
    digitalWrite(ledB, HIGH);
    digitalWrite(ledA, LOW);
    digitalWrite(ledD, LOW);
    digitalWrite(ledC, LOW);
    ledBState=1;
    display.clearDisplay();
    Text("PI RADIO", 50,3,1,false);
    Text(mappedValue, 72, 18, 2, false);
    display.display();
    //EEPROM.write(0, ledB);
   
  } else {
    // turn LED off:
    digitalWrite(ledB, LOW);
    ledBState=0;
    display.clearDisplay();
    //EEPROM.write(0, ledB);
  }
    }
  buttonStateBOld = buttonStateBNew;
  delay(5);
    
  
    if (buttonStateCOld == 0 && buttonStateCNew == 1) {
    // turn LED on:
   if (ledCState == 0){
    digitalWrite(ledC, HIGH);
    digitalWrite(ledA, LOW);
    digitalWrite(ledB, LOW);
    digitalWrite(ledD, LOW);
    ledCState=1;
    display.clearDisplay();
    Text("BLUETOOTH", 45,3,1,false);
    Text(mappedValue, 72, 18, 2, false);
    display.display();
    //EEPROM.write(0, ledC);
   
  } else {
    // turn LED off:
    digitalWrite(ledC, LOW);
    ledCState=0;
    display.clearDisplay();
    //EEPROM.write(0, ledC);
  }
    }
  buttonStateCOld = buttonStateCNew;
  delay(5);
  
  

     if (buttonStateDOld == 0 && buttonStateDNew == 1) {
    // turn LED on:
   if (ledDState == 0){
    digitalWrite(ledD, HIGH);
    digitalWrite(ledA, LOW);
    digitalWrite(ledB, LOW);
    digitalWrite(ledC, LOW);
    ledDState=1;
    display.clearDisplay();
    Text("AUX", 60,3,1,false);
    Text(mappedValue, 72, 18, 2, false);
    display.display();
    //EEPROM.write(0, ledD);
    
   
  } else {
    // turn LED off:
    digitalWrite(ledD, LOW);
    ledDState=0;
    display.clearDisplay();
    //EEPROM.write(0, ledD);
  }
     }
  buttonStateDOld = buttonStateDNew;
  delay(5);

}
long readVolume() {
  // Get the new resistance
//  Position = analogRead(resistancePin);
//return
mappedValue = analogRead(resistancePin);
mappedValue = map(analogRead(resistancePin), 0, 1023, 0,100 );
//mappedValue = virtualPosition;
//delay(50);
}

//void storeVolume() {
  // Ensure INC is HIGH then move CS HIGH and back to LOW
 // digitalWrite(INC, HIGH);
  //delayMicroseconds(1);
  //digitalWrite(CS, HIGH);
 // delay(20);
 // digitalWrite(CS, LOW);
 // Serial.println("Volume stored.");
//}

void Text(String text, int x, int y,int size, boolean d) {

  display.setTextSize(size);
  display.setTextColor(WHITE);
  display.setCursor(x,y);
  display.println(text);
  if(d){
    display.display();
  }
  
  //delay(100);
}
